%define _prefix /usr/local
%define _exec_prefix %{_prefix}
%define _datadir %{prefix}/share

%define _includedir %{_prefix}/include
%define _lib lib
%define _libdir %{_exec_prefix}/%{_lib}
%define _datadir %{_prefix}/share
%define _docdir %{_datadir}/doc
%define _bindir %{_exec_prefix}/bin
%define _sbindir %{_exec_prefix}/sbin
%define _mandir %{_prefix}/man
%define _sysconfdir %{_prefix}/etc
%define _localstatedir %{_prefix}/var

%define aprver 1

# Arches on which the multilib apr.h hack is needed:
%define multilib_arches %{ix86} ia64 ppc ppc64 s390 s390x x86_64

Summary: Apache Portable Runtime library
Name: upenn-apr
Version: 1.4.6
Release: 13%{?dist}
License: Apache Software License
Group: System Environment/Libraries
URL: http://apr.apache.org/
Source0: apr-%{version}.tar.gz
Source1: apr-wrapper.h
# Security fixes
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildPrereq: autoconf, libtool, doxygen, e2fsprogs-devel

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines, forming a system
portability layer to as many operating systems as possible,
including Unices, MS Win32, BeOS and OS/2.

%package devel
Group: Development/Libraries
Summary: APR library development kit
Requires: upenn-apr = %{version}-%{release}, gcc = %(gcc -dumpversion || echo 0.0.0), pkgconfig
# shipped libtool hard-codes paths to gcc libraries in versioned dir

%description devel
This package provides the support files which can be used to 
build applications using the APR library.  The mission of the
Apache Portable Runtime (APR) is to provide a free library of 
C data structures and routines.

%package docs
Group: Development/Documentation
Summary: Documentation for the Apache Portable Runtime library

%description docs
This package provides documentation for the Apache Portable Runtime 
library. The mission of the Apache Portable Runtime (APR) is to provide 
a free library of C data structures and routines, forming a system 
portability layer to as many operating systems as possible, including 
Unices, MS Win32, BeOS and OS/2.

%prep
%setup -q -n apr-%{version}

%build
# regenerate configure script etc.
./buildconf

# Forcibly prevent detection of shm_open (which then picks up but
# does not use -lrt).
export ac_cv_search_shm_open=no

%configure \
        --includedir=%{_includedir}/apr-%{aprver} \
        --with-installbuilddir=%{_libdir}/apr-%{aprver}/build \
        --with-devrandom=/dev/urandom \
        CC=gcc CXX=g++
make %{?_smp_mflags} && make dox

%check
%ifnarch s390 ppc
# Run non-interactive tests.  Skip on platforms which several
# builds might be run concurrently since the test suite binds
# to fixed port numbers in a few places.
#pushd test
( cd test && make all && ./testall -q ) || exit 1
#make %{?_smp_mflags} testall
#./testall -v -q || exit 1
#./testall -v -q || exit 1
#popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# Move docs to more convenient location
mv docs/dox/html html

# Trim exported dependecies
sed -ri '/^dependency_libs/{s,-l(uuid|crypt) ,,g}' \
      $RPM_BUILD_ROOT%{_libdir}/libapr*.la
sed -ri '/^LIBS=/{s,-l(uuid|crypt) ,,g;s/  */ /g}' \
      $RPM_BUILD_ROOT%{_bindir}/apr-%{aprver}-config

%ifarch %{multilib_arches}
# Ugly hack to allow parallel installation of 32-bit and 64-bit apr-devel 
# packages:
mv $RPM_BUILD_ROOT%{_includedir}/apr-%{aprver}/apr.h \
   $RPM_BUILD_ROOT%{_includedir}/apr-%{aprver}/apr-%{_arch}.h
install -c -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_includedir}/apr-%{aprver}/apr.h
%endif

# Unpackaged files:
rm -f $RPM_BUILD_ROOT%{_libdir}/apr.exp

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE NOTICE
%{_libdir}/libapr-%{aprver}.so.*

%files devel
%defattr(-,root,root,-)
%{_bindir}/apr-%{aprver}-config
%{_libdir}/libapr-%{aprver}.*a
%{_libdir}/libapr-%{aprver}.so
%{_libdir}/pkgconfig/*.pc
%dir %{_libdir}/apr-%{aprver}
%dir %{_libdir}/apr-%{aprver}/build
%{_libdir}/apr-%{aprver}/build/*
%dir %{_includedir}/apr-%{aprver}
%{_includedir}/apr-%{aprver}/*.h

%files docs
%doc docs/APRDesign.html docs/canonical_filenames.html
%doc docs/incomplete_types docs/non_apr_programs
%doc --parents html

%changelog
* Wed Sep  7 2011 Garick Hamlin <ghamlin@isc.upenn.edu> 1.4.1-1
- Bump to match new apache build.
